diff --git a/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/OneToManyDialog.js b/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/OneToManyDialog.js
index efcc5e63b..7cb45810d 100644
--- a/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/OneToManyDialog.js
+++ b/web/pgadmin/tools/erd/static/js/erd_tool/dialogs/OneToManyDialog.js
@@ -8,13 +8,48 @@
 //////////////////////////////////////////////////////////////
 
 import gettext from 'sources/gettext';
-import Backform from 'sources/backform.pgadmin';
 import Alertify from 'pgadmin.alertifyjs';
-import $ from 'jquery';
+import BaseUISchema from 'sources/SchemaView/base_schema.ui';
 
 import DialogWrapper from './DialogWrapper';
 import _ from 'lodash';
 
+class OneToManySchema extends BaseUISchema {
+  constructor(fieldOptions={}, initValues={}) {
+    super({
+      local_table_uid: undefined,
+      local_column_attnum: undefined,
+      referenced_table_uid: undefined,
+      referenced_column_attnum: undefined,
+      ...initValues,
+    });
+    this.fieldOptions = fieldOptions;
+  }
+  get baseFields() {
+    return [{
+      id: 'local_table_uid', label: gettext('Local Table'),
+      type: 'select', readonly: true, controlProps: {allowClear: false},
+      options: this.fieldOptions.local_table_uid,
+    }, {
+      id: 'local_column_attnum', label: gettext('Local Column'),
+      type: 'select', options: this.fieldOptions.local_column_attnum,
+      controlProps: {allowClear: false}, noEmpty: true,
+    },{
+      id: 'referenced_table_uid', label: gettext('Referenced Table'),
+      type: 'select', options: this.fieldOptions.referenced_table_uid,
+      controlProps: {allowClear: false}, noEmpty: true,
+    },{
+      id: 'referenced_column_attnum', label: gettext('Referenced Column'),
+      controlProps: {allowClear: false}, deps: ['referenced_table_uid'], noEmpty: true,
+      type: (state)=>({
+        type: 'select',
+        options: state.referenced_table_uid ? ()=>this.fieldOptions.getRefColumns(state.referenced_table_uid) : [],
+        optionsReloadBasis: state.referenced_table_uid,
+      }),
+    }];
+  }
+}
+
 export default class OneToManyDialog {
   constructor(pgBrowser) {
     this.pgBrowser = pgBrowser;
@@ -24,93 +59,32 @@ export default class OneToManyDialog {
     return 'onetomany_dialog';
   }
 
-  getDataModel(attributes, tableNodesDict) {
-    const parseColumns = (columns)=>{
-      return columns.map((col)=>{
+  getUISchema(attributes, tableNodesDict) {
+    let tablesData = [];
+    _.forEach(tableNodesDict, (node, uid)=>{
+      let [schema, name] = node.getSchemaTableName();
+      tablesData.push({value: uid, label: `(${schema}) ${name}`, image: 'icon-table'});
+    });
+
+    return new OneToManySchema({
+      local_table_uid: tablesData,
+      local_column_attnum: tableNodesDict[attributes.local_table_uid].getColumns().map((col)=>{
         return {
-          value: col.attnum, label: col.name,
+          value: col.attnum, label: col.name, 'image': 'icon-column',
         };
-      });
-    };
-
-    let dialogModel = this.pgBrowser.DataModel.extend({
-      defaults: {
-        local_table_uid: undefined,
-        local_column_attnum: undefined,
-        referenced_table_uid: undefined,
-        referenced_column_attnum: undefined,
+      }),
+      referenced_table_uid: tablesData,
+      getRefColumns: (uid)=>{
+        return tableNodesDict[uid].getColumns().map((col)=>{
+          return {
+            value: col.attnum, label: col.name, 'image': 'icon-column',
+          };
+        });
       },
-      schema: [{
-        id: 'local_table_uid', label: gettext('Local Table'),
-        type: 'select2', readonly: true,
-        options: ()=>{
-          let retOpts = [];
-          _.forEach(tableNodesDict, (node, uid)=>{
-            let [schema, name] = node.getSchemaTableName();
-            retOpts.push({value: uid, label: `(${schema}) ${name}`});
-          });
-          return retOpts;
-        },
-      }, {
-        id: 'local_column_attnum', label: gettext('Local Column'),
-        type: 'select2', disabled: false, first_empty: false,
-        editable: true, options: (view)=>{
-          return parseColumns(tableNodesDict[view.model.get('local_table_uid')].getColumns());
-        },
-      },{
-        id: 'referenced_table_uid', label: gettext('Referenced Table'),
-        type: 'select2', disabled: false,
-        editable: true, options: ()=>{
-          let retOpts = [];
-          _.forEach(tableNodesDict, (node, uid)=>{
-            let [schema, name] = node.getSchemaTableName();
-            retOpts.push({value: uid, label: `(${schema}) ${name}`});
-          });
-          return retOpts;
-        },
-      },{
-        id: 'referenced_column_attnum', label: gettext('Referenced Column'),
-        type: 'select2', disabled: false, deps: ['referenced_table_uid'],
-        editable: true, options: (view)=>{
-          if(view.model.get('referenced_table_uid')) {
-            return parseColumns(tableNodesDict[view.model.get('referenced_table_uid')].getColumns());
-          }
-          return [];
-        },
-      }],
-      validate: function(keys) {
-        var msg = undefined;
-
-        // Nothing to validate
-        if (keys && keys.length == 0) {
-          this.errorModel.clear();
-          return null;
-        } else {
-          this.errorModel.clear();
-        }
-
-        if (_.isUndefined(this.get('local_column_attnum')) || this.get('local_column_attnum') == '') {
-          msg = gettext('Select the local column.');
-          this.errorModel.set('local_column_attnum', msg);
-          return msg;
-        }
-        if (_.isUndefined(this.get('referenced_table_uid')) || this.get('referenced_table_uid') == '') {
-          msg = gettext('Select the referenced table.');
-          this.errorModel.set('referenced_table_uid', msg);
-          return msg;
-        }
-        if (_.isUndefined(this.get('referenced_column_attnum')) || this.get('referenced_column_attnum') == '') {
-          msg = gettext('Select the referenced table column.');
-          this.errorModel.set('referenced_column_attnum', msg);
-          return msg;
-        }
-      },
-    });
-
-    return new dialogModel(attributes);
+    }, attributes);
   }
 
-  createOrGetDialog(title) {
+  createOrGetDialog(title, sVersion) {
     const dialogName = this.dialogName();
 
     if (!Alertify[dialogName]) {
@@ -119,19 +93,17 @@ export default class OneToManyDialog {
           `<div class="${dialogName}"></div>`,
           title,
           null,
-          $,
-          this.pgBrowser,
           Alertify,
-          Backform
+          sVersion
         );
       });
     }
     return Alertify[dialogName];
   }
 
-  show(title, attributes, tablesData, sVersion, callback) {
+  show(title, attributes, tablesData, serverInfo, callback) {
     let dialogTitle = title || gettext('Unknown');
-    const dialog = this.createOrGetDialog('onetomany_dialog');
-    dialog(dialogTitle, this.getDataModel(attributes, tablesData), callback).resizeTo(this.pgBrowser.stdW.sm, this.pgBrowser.stdH.md);
+    const dialog = this.createOrGetDialog('onetomany_dialog', serverInfo);
+    dialog(dialogTitle, this.getUISchema(attributes, tablesData), callback).resizeTo(this.pgBrowser.stdW.sm, this.pgBrowser.stdH.md);
   }
 }
